
;******************************** Sub-Intern *******************************
; Sub: Warten 1s
; Parameter:    -
; Return:       - 
; Scratch-Reg:  -
;***************************************************************************
wait_1s:
        push    TEMP_A
		push    TEMP_B
		push    TEMP_C

        ldi     TEMP_A,64                    ; 0,5s
        clr     TEMP_B      	             ; 65536 Durchlufe
        clr     TEMP_C               

w_l2:
        dec     TEMP_B
        brne    w_l2

        dec     TEMP_C                        
        brne    w_l2

        dec     TEMP_A
        brne    w_l2

        pop     TEMP_C
		pop     TEMP_B
        pop     TEMP_A 
        ret

;******************************** Sub-Intern *******************************
; Sub: Copy
; Parameter:    Quelle in X, Ziel in Y, Lnge in TEMP_A
; Return:       - 
; Scratch-Reg:  -
;***************************************************************************
copy_ram:
		ld		TEMP_B,X+
		st		Y+,TEMP_B
		dec		TEMP_A
		brne	copy_ram

		ret

;******************************** Sub-Intern *******************************
; Sub: Copy
; Parameter:    Quelle in Z, Ziel in Y
; Return:       - 
; Scratch-Reg:  -
;***************************************************************************
copy_http:
		clr		XL					; Zhler
		clr		XH

copy_http_loop:
		lpm		TEMP_A,Z+
		tst		TEMP_A
		breq	copy_http_loop		; 0 ignorieren

		st		Y+,TEMP_A
		adiw	X,1					; Zhler erhhen
		cpi		TEMP_A,$FF			; Ende?
		brne	copy_http_loop		; nein, weiter
		
		sts		TCP_D_LEN,XH		; HTTP_Daten
		sts		TCP_D_LEN+1,XL		

copy_http_end:
		ret

;******************************** Sub-Intern *******************************
; Sub: Testet, ob eigene IP, Zeiger in Z
; Parameter:    
; Return:       Z gesetzt - ok 
; Scratch-Reg:  -
;***************************************************************************
check_ip:
		load_p	Y,INT_IP
		ldi		TEMP_C,4						; Counter

check_ip_loop:
		ld		TEMP_A,Z+
		ld		TEMP_B,Y+
		cp		TEMP_A,TEMP_B
		brne	check_ip_end					; nicht meine IP gesucht
		
		dec		TEMP_C
		brne	check_ip_loop

check_ip_end:
		ret

;******************************** Sub-Intern *******************************
; Sub: erhht Sequenznummer in TEMP_0 - 3
; Parameter:    
; Return:       Z gesetzt - ok 
; Scratch-Reg:  -
;***************************************************************************
inc_seq_nr:
		ldi		TEMP_A,1
		clr		TEMP_B
		add		TEMP_3,TEMP_A
		adc		TEMP_2,TEMP_B
		adc		TEMP_1,TEMP_B
		adc		TEMP_0,TEMP_B

		ret

;******************************** Sub-Intern *******************************
; Sub: Berechnet IP - Checksumme
; Parameter:    Z zeigt auf Buffer, X ist Headerlen
; Return:       X - Checksumme
; Scratch-Reg:  -
;***************************************************************************
make_chksum_16:
		clr		TEMP_0
		clr		TEMP_1
		clr		TEMP_2
		clr		TEMP_3

make_chksum_16_loop:		
		ld		TEMP_B,Z+						; High
		ld		TEMP_C,Z+						; Low
		add		TEMP_0,TEMP_C
		adc		TEMP_1,TEMP_B
		clr		TEMP_C
		adc		TEMP_2,TEMP_C					; 0
		adc		TEMP_3,TEMP_C					; 0
	
		sbiw	X,2								; Lnge -2
		breq	make_chksum_16_ok				; 0 - fertig

		tst		XH
		brne	make_chksum_16_loop				; auf jeden Fall weiter
		
		cpi		XL,2					
		brge	make_chksum_16_loop				; war 1 oder 0 Byte brig

		ld		TEMP_B,Z+						; High
		clr		TEMP_C							; Low
		add		TEMP_0,TEMP_C
		adc		TEMP_1,TEMP_B
		adc		TEMP_2,TEMP_C					; 0
		adc		TEMP_3,TEMP_C					; 0

make_chksum_16_ok:
		add		TEMP_0,TEMP_2
		adc		TEMP_1,TEMP_3

		com		TEMP_0
		com		TEMP_1

		mov		XL,TEMP_0
		mov		XH,TEMP_1
						
		ret

;******************************** Sub-Intern *******************************
; Sub: Berechnet IP - Datenlnge fr IP-Payload
; Parameter:    -
; Return:       Lnge ohne Header in X
; Scratch-Reg:  -
;***************************************************************************
get_ip_data_len:
		lds		XH,IP_TOT_LEN
		lds		XL,IP_TOT_LEN+1
		lds		TEMP_A,IP_VER_LEN
		andi	TEMP_A,$0F

		lsl		TEMP_A
		lsl		TEMP_A

		sub		XL,TEMP_A
		clr		TEMP_A
		sbc		XH,TEMP_A	
		
		ret
