
;******************************* Sub-Debug *********************************
; Sub: Sendet Text ber die serielle Schnittstelle
; Parameter:   Z enthlt den Zeiger auf den Text im ROM
; Return:
; Scratch-Reg: COUNTER_1, COPY, TEMP_A, ZL, ZH
;***************************************************************************
send_text:
        lpm		TEMP_A,Z+
		tst		TEMP_A
		breq	send_text_end			; Ende

        rcall   send_byte

		brne    send_text				; weiter

send_text_end:
        ret

;******************************* Sub-Debug *********************************
; Sub: Sendet NL/CR ber die serielle Schnittstelle
; Parameter:   -
; Return:      -
; Scratch-Reg: TEMP_A
;***************************************************************************
send_newline:
        push    TEMP_A
		ldi     TEMP_A,$0A
        rcall   send_byte
		ldi     TEMP_A,$0D
        rcall   send_byte
        pop     TEMP_A
		ret

;******************************* Sub-UART **********************************
; Sub: Sendet ein Byte aus TEMP_A als HEX-Dump ber UART
; Parameter:
; Return:
; Scratch-Reg: TEMP_A, TEMP_B
;***************************************************************************
send_byte_hex:
        push TEMP_A
		push TEMP_B
        ldi  TEMP_B,7
        push TEMP_A
		swap TEMP_A
		andi TEMP_A,$0F
		ori  TEMP_A,$30                    ; nach Ziffer
		cpi  TEMP_A,$3A                    ; 0...9
    	brlo wb_1
        add  TEMP_A,TEMP_B                 ; A...F
wb_1:
        rcall send_byte
		pop  TEMP_A
		andi TEMP_A,$0F
		ori  TEMP_A,$30                   ; nach Ziffer
		cpi  TEMP_A,$3A                   ; 0...9
		brlo wb_2
        add  TEMP_A,TEMP_B                ; A...F
wb_2:
        rcall send_byte
        pop   TEMP_B
		pop   TEMP_A
        ret

;******************************* Sub-UART **********************************
; Sub: Sendet ein Byte aus TEMP_A als Dezimalwert ber UART
; Parameter: TEMP_A
; Return:	 TEMP_C, TEMP_B, TEMP_A
; Scratch-Reg: TEMP_A, TEMP_B
;***************************************************************************
send_byte_dez:
		clr		TEMP_B
		clr		TEMP_C

loop_100:
		inc		TEMP_C
		subi	TEMP_A,100
		brcc	loop_100
		
		dec		TEMP_C				; letztes wieder zurck
		subi	TEMP_A,-100							

loop_10:
		inc		TEMP_B
		subi	TEMP_A,10
		brcc	loop_10
		
		dec		TEMP_B				; letztes wieder zurck
		subi	TEMP_A,-10							

		ori		TEMP_C,$30		
		ori		TEMP_B,$30
		ori		TEMP_A,$30
		push	TEMP_A
		mov		TEMP_A,TEMP_C
		rcall	send_byte
		mov		TEMP_A,TEMP_B
		rcall	send_byte
		pop		TEMP_A
		rcall	send_byte
			
        ret

;******************************* Sub-UART **********************************
; Sub: Sendet ein Byte aus TEMP_A ber UART
; Parameter:    -
; Return:       -
; Scratch-Reg:  -
;***************************************************************************
send_byte:
        sbis    UCSRA,UDRE                  ; Send-Register leer ?
        rjmp    send_byte              	    ; nein

        out     UDR,TEMP_A
        ret

